Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.search.util
Class WeakIdentityHashMap

    java.lang.Object
      org.hibernate.search.util.WeakIdentityHashMap

All Implemented Interfaces:
  Map

    public class WeakIdentityHashMap

extends Object
implements Map

A hashtable-based `Map` implementation with weak keys and using reference-equality in place of object-equality when comparing keys (and values). In an `WeakIdentityHashMap`, two keys `k1` and `k2` are considered equal if and only if `(k1==k2)`. An entry in a `WeakIdentityHashMap` will automatically be removed when its key is no longer in ordinary use. More precisely, the presence of a mapping for a given key will not prevent the key from being discarded by the garbage collector, that is, made finalizable, finalized, and then reclaimed. When a key has been discarded its entry is effectively removed from the map.

Based on java.util.WeakHashMap

Based on org.jboss.common.collection.WeakIdentityHashMap

Author:
  Dawid Kurzyniec, Kabir Khan, Emmanuel Bernard
See Also:
  `IdentityHashMap`, `WeakHashMap`

Constructor Summary
`WeakIdentityHashMap()` Constructs a new, empty `WeakIdentityHashMap` with the default initial capacity (16) and the default load factor (0.75).
`WeakIdentityHashMap(int initialCapacity)` Constructs a new, empty `WeakIdentityHashMap` with the given initial capacity and the default load factor, which is `0.75`.
`WeakIdentityHashMap(int initialCapacity, float loadFactor)` Constructs a new, empty `WeakIdentityHashMap` with the given initial capacity and the given load factor.
`WeakIdentityHashMap(Map t)` Constructs a new `WeakIdentityHashMap` with the same mappings as the specified `Map`.

Method Summary
`void` | `clear()` Removes all mappings from this map.
`boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`Set` | `entrySet()` Returns a collection view of the mappings contained in this map.
`Object` | `get(Object key)` Returns the value to which the specified key is mapped in this weak hash map, or `null` if the map contains no mapping for this key.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`Set` | `keySet()` Returns a set view of the keys contained in this map.
`Object` | `put(Object key, Object value)` Associates the specified value with the specified key in this map.
`void` | `putAll(Map t)` Copies all of the mappings from the specified map to this map These mappings will replace any mappings that this map had for any of the keys currently in the specified map.
`Object` | `remove(Object key)` Removes the mapping for this key from this map if present.
`boolean` | `removeValue(Object value)` Remove elements having the according value.
`int` | `size()` Returns the number of key-value mappings in this map.
`Collection` | `values()` Returns a collection view of the values contained in this map.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode`

Constructor Detail

### WeakIdentityHashMap

    public WeakIdentityHashMap(int initialCapacity,
                               float loadFactor)

  Constructs a new, empty `WeakIdentityHashMap` with the given initial capacity and the given load factor.

  Parameters:
    `initialCapacity` - The initial capacity of the `WeakIdentityHashMap`
    `loadFactor` - The load factor of the `WeakIdentityHashMap`
  Throws:
    `IllegalArgumentException` - If the initial capacity is negative, or if the load factor is nonpositive.

### WeakIdentityHashMap

    public WeakIdentityHashMap(int initialCapacity)

  Constructs a new, empty `WeakIdentityHashMap` with the given initial capacity and the default load factor, which is `0.75`.

  Parameters:
    `initialCapacity` - The initial capacity of the `WeakIdentityHashMap`
  Throws:
    `IllegalArgumentException` - If the initial capacity is negative.

### WeakIdentityHashMap

    public WeakIdentityHashMap()

  Constructs a new, empty `WeakIdentityHashMap` with the default initial capacity (16) and the default load factor (0.75).

### WeakIdentityHashMap

    public WeakIdentityHashMap(Map t)

  Constructs a new `WeakIdentityHashMap` with the same mappings as the specified `Map`. The `WeakIdentityHashMap` is created with default load factor, which is `0.75` and an initial capacity sufficient to hold the mappings in the specified `Map`.

  Parameters:
    `t` - the map whose mappings are to be placed in this map.
  Throws:
    `NullPointerException` - if the specified map is null.

Method Detail

### size

    public int size()

  Returns the number of key-value mappings in this map. This result is a snapshot, and may not reflect unprocessed entries that will be removed before next attempted access because they are no longer referenced.

  Specified by:
    `size` in interface `Map`

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings. This result is a snapshot, and may not reflect unprocessed entries that will be removed before next attempted access because they are no longer referenced.

  Specified by:
    `isEmpty` in interface `Map`

### get

    public Object get(Object key)

  Returns the value to which the specified key is mapped in this weak hash map, or `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it is also possible that the map explicitly maps the key to `null`. The `containsKey` method may be used to distinguish these two cases.

  Specified by:
    `get` in interface `Map`
  Parameters:
    `key` - the key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key, or `null` if the map contains no mapping for this key.
  See Also:
    `put(Object,Object)`

### containsKey

    public boolean containsKey(Object key)

  Returns `true` if this map contains a mapping for the specified key.

  Specified by:
    `containsKey` in interface `Map`
  Parameters:
    `key` - The key whose presence in this map is to be tested
  Returns:
    `true` if there is a mapping for `key`; `false` otherwise

### put

    public Object put(Object key,
                      Object value)

  Associates the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced.

  Specified by:
    `put` in interface `Map`
  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the HashMap previously associated `null` with the specified key.

### putAll

    public void putAll(Map t)

  Copies all of the mappings from the specified map to this map These mappings will replace any mappings that this map had for any of the keys currently in the specified map.

  Specified by:
    `putAll` in interface `Map`
  Parameters:
    `t` - mappings to be stored in this map.
  Throws:
    `NullPointerException` - if the specified map is null.

### remove

    public Object remove(Object key)

  Removes the mapping for this key from this map if present.

  Specified by:
    `remove` in interface `Map`
  Parameters:
    `key` - key whose mapping is to be removed from the map.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.

### clear

    public void clear()

  Removes all mappings from this map.

  Specified by:
    `clear` in interface `Map`

### containsValue

    public boolean containsValue(Object value)

  Returns `true` if this map maps one or more keys to the specified value.

  Specified by:
    `containsValue` in interface `Map`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.

### removeValue

    public boolean removeValue(Object value)

  Remove elements having the according value. Intended to avoid concurrent access exceptions It is expected that nobody add a key being removed by value

  Parameters:
    `value` - value whose presence in this map is to be removed.
  Returns:
    `true` if this map maps one or more keys to the specified value.

### keySet

    public Set keySet()

  Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `keySet` in interface `Map`
  Returns:
    a set view of the keys contained in this map.

### values

    public Collection values()

  Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `values` in interface `Map`
  Returns:
    a collection view of the values contained in this map.

### entrySet

    public Set entrySet()

  Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  Specified by:
    `entrySet` in interface `Map`
  Returns:
    a collection view of the mappings contained in this map.
  See Also:
    `Map.Entry`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD